import debug from 'debug';
/**
 * Log a message in the @imgix/gatsby namespace
 */
export declare const log: debug.IDebugger;
/**
 * Create a custom logger to group logs by a namespace.
 * @param module The namespace to use for the logger
 */
export declare const createLogger: (module: string) => debug.IDebugger;
/**
 * Create a tracer (function that can be used to log a message)
 * @param label A prefix to add to the message
 * @param logger Custom debug logger to use if needed
 * @returns A function that takes a message to log
 */
export declare const trace: (label?: string, customLogger?: debug.IDebugger) => <T>(v: T) => T;
/**
 * Log out a JSON value.
 * @param rawJSON JSON data to lo
 * @param label Prefix to add to log message
 * @param customLogger Custom debug logger to use if created
 */
export declare const traceJSON: (rawJSON: any, label?: string | null | undefined, customLogger?: debug.IDebugger) => void;
//# sourceMappingURL=log.d.ts.map