"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createImgixGatsbyImageSchemaFieldConfig = exports.createImgixGatsbyImageFieldConfig = void 0;
var common_tags_1 = require("common-tags");
var gatsby_plugin_image_1 = require("gatsby-plugin-image");
var graphql_utils_1 = require("gatsby-plugin-image/graphql-utils");
var ramda_1 = require("ramda");
var fetchBase64Image_1 = require("../../api/fetchBase64Image");
var createExternalHelper_1 = require("../../common/createExternalHelper");
var buildGatsbyImageDataBaseArgs_1 = require("./buildGatsbyImageDataBaseArgs");
var graphqlTypes_1 = require("./graphqlTypes");
var resolveDimensions_1 = require("./resolveDimensions");
/**
 * Resolve gatsby image data for a given node
 * @param param0
 * @param param0.resolveUrl Function that returns the url or a Promise containing the url for the given node
 * @param param0.imgixClient An instance of an imgix client
 * @param param0.resolveHeight Function that returns the height of the image, if given in the source data, to prevent unnecessary data fetching
 * @param param0.resolveWidth Function that returns the width of the image, if given in the source data, to prevent unnecessary data fetching
 * @param param0.cache The Gatsby cache helper
 * @param param0.defaultParams The default imgix params to set on the image requested
 * @returns A GraphQL resolver (a function that accepts the node value and args, and returns gatsby image data in a Promise)
 */
var resolveGatsbyImageData = function (_a) {
    var resolveUrl = _a.resolveUrl, imgixClient = _a.imgixClient, _b = _a.resolveWidth, resolveWidth = _b === void 0 ? function () { return undefined; } : _b, _c = _a.resolveHeight, resolveHeight = _c === void 0 ? function () { return undefined; } : _c, cache = _a.cache, defaultParams = _a.defaultParams;
    return function (rootValue, unsafeResolverArgs) { return __awaiter(void 0, void 0, void 0, function () {
        var url, manualWidth, manualHeight, safeResolverArgs, dimensions, baseImageDataArgs, placeholderData, error_1;
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 6, , 7]);
                    return [4 /*yield*/, resolveUrl(rootValue)];
                case 1:
                    url = _c.sent();
                    if (!url) {
                        return [2 /*return*/, undefined];
                    }
                    return [4 /*yield*/, resolveWidth(rootValue)];
                case 2:
                    manualWidth = _c.sent();
                    return [4 /*yield*/, resolveHeight(rootValue)];
                case 3:
                    manualHeight = _c.sent();
                    safeResolverArgs = __assign(__assign({}, unsafeResolverArgs), { imgixParams: (0, graphqlTypes_1.unTransformParams)((_a = unsafeResolverArgs.imgixParams) !== null && _a !== void 0 ? _a : {}), placeholderImgixParams: (0, graphqlTypes_1.unTransformParams)((_b = unsafeResolverArgs.placeholderImgixParams) !== null && _b !== void 0 ? _b : {}) });
                    return [4 /*yield*/, (0, resolveDimensions_1.resolveDimensions)({
                            url: url,
                            manualHeight: manualHeight,
                            manualWidth: manualWidth,
                            cache: cache,
                            client: imgixClient,
                        })];
                case 4:
                    dimensions = _c.sent();
                    baseImageDataArgs = (0, buildGatsbyImageDataBaseArgs_1.buildGatsbyImageDataBaseArgs)({
                        url: url,
                        dimensions: dimensions,
                        resolverArgs: safeResolverArgs,
                        defaultParams: defaultParams,
                        imgixClient: imgixClient,
                    });
                    return [4 /*yield*/, generatePlaceHolderData({
                            safeResolverArgs: safeResolverArgs,
                            baseImageDataArgs: baseImageDataArgs,
                            cache: cache,
                            defaultParams: defaultParams,
                            imgixClient: imgixClient,
                            url: url,
                        })];
                case 5:
                    placeholderData = _c.sent();
                    return [2 /*return*/, __assign(__assign({}, (0, gatsby_plugin_image_1.generateImageData)(__assign({}, baseImageDataArgs))), placeholderData)];
                case 6:
                    error_1 = _c.sent();
                    return [2 /*return*/, undefined];
                case 7: return [2 /*return*/];
            }
        });
    }); };
};
/**
 * Create the GraphQL field config for the gatsbyImage field that will exist on
 * the imgixImage type
 * @param param0
 * @param param0.cache Gatsby cache
 * @param param0.imgixClient The imgix client to use to build the URL
 * @param param0.resolveUrl The function to resolve the URL from the source data
 * @param param0.defaultParams The default params to use when building the fixed image URL
 * @param param0.paramsInputType The GraphQL type to use for the params input
 * @param param0.placeholderEnumType The GraphQL type to use for the placeholder enum
 * @param param0.resolveWidth A function should should resolve the width from the source data. If not provided, the imgix api will be used to find the image width
 * @param param0.resolveHeight A function should should resolve the height from the source data. If not provided, the imgix api will be used to find the image height
 * @returns A GraphQL field config for a "gatsbyImage" field
 */
var createImgixGatsbyImageFieldConfig = function (_a) {
    var cache = _a.cache, imgixClient = _a.imgixClient, resolveUrl = _a.resolveUrl, defaultParams = _a.defaultParams, paramsInputType = _a.paramsInputType, placeholderEnumType = _a.placeholderEnumType, resolveWidth = _a.resolveWidth, resolveHeight = _a.resolveHeight;
    var defaultConfig = (0, graphql_utils_1.getGatsbyImageFieldConfig)(resolveGatsbyImageData({
        cache: cache,
        imgixClient: imgixClient,
        resolveUrl: resolveUrl,
        defaultParams: defaultParams,
        resolveWidth: resolveWidth,
        resolveHeight: resolveHeight,
    }), // TODO: remove cast when PR to Gatsby has been merged
    {});
    var defaultArgs = defaultConfig.args;
    // ⚠️ KEEP THESE IN SYNC WITH IImgixGatsbyImageDataArgs!! ⚠️
    var modifiedConfig = __assign(__assign({}, defaultConfig), { args: __assign(__assign({}, (0, ramda_1.pick)([
            'layout',
            'width',
            'height',
            'aspectRatio',
            'outputPixelDensities',
            'breakpoints',
            'sizes',
            'backgroundColor',
        ], defaultArgs)), { imgixParams: {
                type: paramsInputType,
                description: (0, common_tags_1.stripIndent)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["This argument is used to set parameters to instruct imgix to transform the image. \n        \n        All of imgix's parameters can be found here: https://docs.imgix.com/apis/rendering\n        "], ["This argument is used to set parameters to instruct imgix to transform the image. \n        \n        All of imgix's parameters can be found here: https://docs.imgix.com/apis/rendering\n        "]))),
            }, placeholderImgixParams: {
                type: paramsInputType,
                description: (0, common_tags_1.stripIndent)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["This argument is used to set parameters to instruct imgix to transform the placeholder image. By default all parameters passed to 'imgixParams' are already set here, but this can be used to override or set extra parameters. \n        \n        All of imgix's parameters can be found here: https://docs.imgix.com/apis/rendering\n        "], ["This argument is used to set parameters to instruct imgix to transform the placeholder image. By default all parameters passed to 'imgixParams' are already set here, but this can be used to override or set extra parameters. \n        \n        All of imgix's parameters can be found here: https://docs.imgix.com/apis/rendering\n        "]))),
            }, placeholder: {
                type: placeholderEnumType,
                description: (0, common_tags_1.stripIndent)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n          Format of generated placeholder image, displayed while the main image loads.\n          BLURRED: a blurred, low resolution image, encoded as a base64 data URI (default)\n          DOMINANT_COLOR: a solid color, calculated from the dominant color of the image.\n          NONE: no placeholder. Set \"backgroundColor\" to use a fixed background color."], ["\n          Format of generated placeholder image, displayed while the main image loads.\n          BLURRED: a blurred, low resolution image, encoded as a base64 data URI (default)\n          DOMINANT_COLOR: a solid color, calculated from the dominant color of the image.\n          NONE: no placeholder. Set \"backgroundColor\" to use a fixed background color."]))),
            }, widthTolerance: {
                type: 'Float',
                description: (0, common_tags_1.stripIndent)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n          This argument affects the breakpoints used for the srcsets, dictates the maximum tolerated size difference between an image's downloaded size and its rendered size. For example: setting this value to 0.1 means that an image will not render more than 10% larger or smaller than its native size. In practice, the image URLs generated for a width-based srcset attribute will grow by twice this rate. A lower tolerance means images will render closer to their native size (thereby increasing perceived image quality), but a large srcset list will be generated and consequently users may experience lower rates of cache-hit for pre-rendered images on your site.\n\n          By default this rate is set to 8 percent, which we consider to be the ideal rate for maximizing cache hits without sacrificing visual quality. Users can specify their own width tolerance by providing a positive scalar value as widthTolerance to the third options object:"], ["\n          This argument affects the breakpoints used for the srcsets, dictates the maximum tolerated size difference between an image's downloaded size and its rendered size. For example: setting this value to 0.1 means that an image will not render more than 10% larger or smaller than its native size. In practice, the image URLs generated for a width-based srcset attribute will grow by twice this rate. A lower tolerance means images will render closer to their native size (thereby increasing perceived image quality), but a large srcset list will be generated and consequently users may experience lower rates of cache-hit for pre-rendered images on your site.\n\n          By default this rate is set to 8 percent, which we consider to be the ideal rate for maximizing cache hits without sacrificing visual quality. Users can specify their own width tolerance by providing a positive scalar value as widthTolerance to the third options object:"]))),
                defaultValue: 0.08,
            }, srcSetMinWidth: {
                type: 'Int',
                description: (0, common_tags_1.stripIndent)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n          This argument determines the minimum srcset width that is generated. The default is 100px.\n        "], ["\n          This argument determines the minimum srcset width that is generated. The default is 100px.\n        "]))),
                defaultValue: 100,
            }, srcSetMaxWidth: {
                type: 'Int',
                description: (0, common_tags_1.stripIndent)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n          This argument determines the maximum srcset width that is generated, if the layout type is FULL_WIDTH. If the layout type is CONSTRAINED, the width argument will be used. Furthermore, in every case, the maximum srcset width is constrained by the width of the source image. The default is 8192px, which is the render limit of the imgix service.\n        "], ["\n          This argument determines the maximum srcset width that is generated, if the layout type is FULL_WIDTH. If the layout type is CONSTRAINED, the width argument will be used. Furthermore, in every case, the maximum srcset width is constrained by the width of the source image. The default is 8192px, which is the render limit of the imgix service.\n        "]))),
                defaultValue: 8192,
            } }) });
    return modifiedConfig;
};
exports.createImgixGatsbyImageFieldConfig = createImgixGatsbyImageFieldConfig;
exports.createImgixGatsbyImageSchemaFieldConfig = (0, createExternalHelper_1.createExternalHelper)(exports.createImgixGatsbyImageFieldConfig);
/**
 * Create placeholder data which is compatible with the gatsby image data
 * placeholder format.
 */
function generatePlaceHolderData(_a) {
    var safeResolverArgs = _a.safeResolverArgs, baseImageDataArgs = _a.baseImageDataArgs, cache = _a.cache, defaultParams = _a.defaultParams, imgixClient = _a.imgixClient, url = _a.url;
    return __awaiter(this, void 0, void 0, function () {
        var lowResImageUrl, base64Data, dominantColor;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(safeResolverArgs.placeholder === 'blurred')) return [3 /*break*/, 2];
                    lowResImageUrl = (0, gatsby_plugin_image_1.getLowResolutionImageURL)(__assign(__assign({}, baseImageDataArgs), { options: __assign(__assign({}, baseImageDataArgs), { imgixParams: __assign(__assign(__assign({}, defaultParams), safeResolverArgs.imgixParams), safeResolverArgs.placeholderImgixParams) }) }));
                    return [4 /*yield*/, (0, fetchBase64Image_1.fetchImgixBase64Image)(cache)(lowResImageUrl)];
                case 1:
                    base64Data = _b.sent();
                    return [2 /*return*/, {
                            placeholder: { fallback: base64Data },
                        }];
                case 2:
                    if (!(safeResolverArgs.placeholder === 'dominantColor')) return [3 /*break*/, 4];
                    return [4 /*yield*/, (0, fetchBase64Image_1.fetchImgixDominantColor)(cache)(function (params) {
                            return imgixClient.buildURL(url, __assign(__assign(__assign(__assign({}, defaultParams), safeResolverArgs.imgixParams), safeResolverArgs.placeholderImgixParams), params));
                        })];
                case 3:
                    dominantColor = _b.sent();
                    return [2 /*return*/, {
                            backgroundColor: dominantColor,
                        }];
                case 4: return [2 /*return*/, {}];
            }
        });
    });
}
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
//# sourceMappingURL=createImgixGatsbyImageDataFieldConfig.js.map