"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveDimensions = void 0;
var fetchImgixMetadata_1 = require("../../api/fetchImgixMetadata");
var log_1 = require("../../common/log");
var log = (0, log_1.createLogger)('resolveDimensions');
/**
 * Calculate the dimensions of an image, using manual dimensions, if provided,
 * or otherwise by using the imgix API
 * @param param0
 * @param param0.url The URL of the image
 * @param param0.manualWidth The width of the image, if known
 * @param param0.manualHeight The height of the image, if known
 * @param param0.cache Gatsby cache
 * @param param0.client Instance of the imgix client
 * @returns The width and height of the image, or an error
 */
var resolveDimensions = function (_a) {
    var url = _a.url, manualHeight = _a.manualHeight, manualWidth = _a.manualWidth, cache = _a.cache, client = _a.client;
    return __awaiter(void 0, void 0, void 0, function () {
        var _b, PixelWidth, PixelHeight, error_1;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (manualWidth != null && manualHeight != null) {
                        (0, log_1.traceJSON)({ manualWidth: manualWidth, manualHeight: manualHeight }, 'manual dimensions used', log);
                        return [2 /*return*/, {
                                width: manualWidth,
                                height: manualHeight,
                            }];
                    }
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 3, , 4]);
                    log('no manual dimensions found, fetching image dimensions from imgix API');
                    return [4 /*yield*/, (0, fetchImgixMetadata_1.fetchImgixMetadata)(cache, client)(url)];
                case 2:
                    _b = _c.sent(), PixelWidth = _b.PixelWidth, PixelHeight = _b.PixelHeight;
                    (0, log_1.traceJSON)({ PixelWidth: PixelWidth, PixelHeight: PixelHeight }, 'metadata result', log);
                    return [2 /*return*/, {
                            width: PixelWidth,
                            height: PixelHeight,
                        }];
                case 3:
                    error_1 = _c.sent();
                    throw new Error('Something went wrong fetching the image metadata');
                case 4: return [2 /*return*/];
            }
        });
    });
};
exports.resolveDimensions = resolveDimensions;
//# sourceMappingURL=resolveDimensions.js.map